#include	"stdio.h"
#include	<stdarg.h>

#include	"realdeal.h"

void	console_out_char(ConsoleInfo	*info, char	c);

FileData	console_file = {1, 0, -1, 0};

char	inputbuffer[512];
int		inputlength=0;

FILE	*stdin = (FILE*)(&console_file),
		*stdout = (FILE*)(&console_file),
		*stderr = (FILE*)(&console_file);

int	printf(char	*format, ...)
{
	va_list	args;
	int		ret;
	
	va_start(args, format);
	ret = vfprintf(stdout, format, args);
	va_end(args);
	
	return ret;
}

initialize_console(FileData	*fd)
{
	Rect	r = {95, 45, 106 + 40*14, 56 + 80*7};
	ConsoleInfo	*cinfo;
	int		x, y;
	
	InitCursor();
	cinfo = (ConsoleInfo*)NewPtr(sizeof(ConsoleInfo));
	fd->console = NewCWindow(nil, &r, "\pConsole", true, 0,
							 (WindowPtr)-1L, false, (int)(cinfo));
	ShowWindow(fd->console);
	
	for(x=0;x<80;x++)
		for(y=0;y<40;y++)
			cinfo->text[x][y] = ' ';
	cinfo->x = cinfo->y = 0;
}

console_out_string(FileData	*fd, char	*string, long	len)
{
	ConsoleInfo	*cinfo;
	short		num;
	CGrafPtr	oldPort;
	
	if(fd->console == 0)initialize_console(fd);
	
	GetPort(&oldPort);
	SetPortWindowPort(fd->console);
	GetFNum("\pMonaco", &num);
	TextFont(num);
	cinfo = (ConsoleInfo*)GetWRefCon(fd->console);
	while(*string)console_out_char(cinfo, *string++);
	SetPort(oldPort);
}

backup(ConsoleInfo	*info)
{
	info->x--;
	if(info->x<0)
	{
		info->x = 79;
		info->y--;
	}
}

void	console_out_char(ConsoleInfo	*info, char	c)
{
	Rect	entire = {5, 5, 5 + 14*40, 5 + 7*80},
			lastline = {5 + 14*39, 5, 5 + 14*40, 5 + 7*80};
	
	TextMode(srcCopy);
	if(c == 10 || c==11 || c==13)goto newline;
	if(c == 8)
	{
		backup(info);
		console_out_char(info, ' ');
		backup(info);
		return;
	}
	MoveTo(5 + info->x * 7, 5 + info->y * 14 + 10);
	DrawChar(c);
	info->text[info->x][info->y] = c;
	info->x++;
	if(info->x >= 80)
	{
		newline:
		info->x = 0;
		info->y++;
	}
	
	if(info->y >= 40)
	{
		info->y--;
		ScrollRect(&entire, 0, -14, nil);
		EraseRect(&lastline);
	}
}

int	console_fgetc()
{
	char	c;
	
	if(inputlength<=0)wait_for_input();
	c = inputbuffer[0];
	consume_input(1);
	return c;
}

console_ungetc(int	c)
{
	int	i;
	
	for(i=inputlength;i>=0;i--)
		inputbuffer[i+1] = inputbuffer[i];
	inputlength++;
	inputbuffer[0] = (char)c;
	console_file.pushback++;
}

consume_input(int	len)
{
	int	i;
	
	for(i=0;i<=(inputlength-len);i++)
		inputbuffer[i] = inputbuffer[i+len];
	inputlength -= len;
	
	if(len > console_file.pushback)
		console_file.pushback = 0;
	else console_file.pushback -= len;
}

wait_for_input()
{
	EventRecord	ev;
	
	while(1)
	{
		if(WaitNextEvent(everyEvent, &ev, 2L, nil))
		{
			if(ev.what == keyDown)
			{
				if(((char)ev.message)==8)
				{
					inputlength--;
					if(inputlength<0)inputlength=0;
					else printf("%c", (char)ev.message);
					continue;
				}
				else printf("%c", (char)ev.message);
				if(((char)ev.message)==10 || ((char)ev.message)==11 || ((char)ev.message)==13)
				{
					inputbuffer[inputlength++] = ((char)ev.message);
					inputbuffer[inputlength] = 0;
					return;
				}
				
				inputbuffer[inputlength++] = ((char)ev.message);
			}
			else if(ev.what == updateEvt)
			{
				BeginUpdate((WindowPtr)ev.message);
				
				EndUpdate((WindowPtr)ev.message);
			}
		}
	}
}

int	console_in_string(char	*str, int	length)
{
	if(length > inputlength)
	{
		strcpy(str, inputbuffer);
		length = inputlength;
		consume_input(inputlength);
		return length;
	}
	else
	{
		strncpy(str, inputbuffer, length);
		consume_input(length);
		return length;
	}
}

int	scanf(char	*format, ...)
{
	va_list	args;
	int		ret, used, trynum = 0;
	
	while(inputlength && inputbuffer[0]<' ')consume_input(1);
	tryagain:
	trynum++;
	if(inputlength==0)wait_for_input();
	
	va_start(args, format);
	ret = vsscanf_with_count(inputbuffer, &used, format, args);
	va_end(args);
	
	if(ret>=0)
	{
		consume_input(used);
	}
	else if(trynum<2 && inputlength)
	{
		consume_input(inputlength);
		goto tryagain;
	}
	
	return ret;
}