#include	"realdeal.h"
#include	<stdarg.h>


void *memcpy(void *dest, void *source, int n)
{
	int i;
	char *destc, *sourcec;
	
	destc = (char*) dest;
	sourcec = (char*) source;
	
	for(i=0; i < n ; i++)
		destc[i] = sourcec[i];
	
	return dest;
}


int		strlen(char	*string)
{
	char	*ptr = string;
	
	while(*ptr++) { }
	
	return ptr - string - 1;
}

char	*strcpy(char	*dst, char	*src)
{
	int	i = 0;
	
	while(dst[i] = src[i])i++;
	
	return dst;
}

char	*strncpy(char	*dst, char	*src, int	n)
{
	int	i = 0;
	
	while((dst[i] = src[i]) && i<n)i++;
	
	return dst;
}

int		strcmp(char	*d, char	*s)
{
	int	diff, i;
	char *dd, *ss;
	 
	i=0;
	diff = 0;
	
	do 
	{ 
		i++;
		diff += (*d != *s) * ((*d < *s) ? -1 : 1) * i;
	} while (*s++ && *d++);
	
	return diff;
}

int		strncmp(char	*d, char	*s, int	n)
{
	int	diff = 0;
	int	i = 0;
	
	if(!n)return 0;
	do { i++; diff += *d - *s; } while (*s++ && *d++ && i<n);
	
	return diff;
}

char	*strcat(char	*s1, char	*s2)
{
	strcpy(s1 + strlen(s1), s2);
	return s1;
}

char	*strchr(char	*s, int	c)
{
	while(*s && *s!=c)s++;
	if(*s != c)return 0;
	return s;
}

int	sprintf(char	*string, char	*format, ...)
{
	va_list	args;
	int		ret;
	
	va_start(args, format);
	ret = vsprintf(string, format, args);
	va_end(args);
	
	return ret;
}

int	sscanf(char	*string, char	*format, ...)
{
	va_list	args;
	int		ret;
	
	va_start(args, format);
	ret = vsscanf(string, format, args);
	va_end(args);
	
	return ret;
}

int	string_number(char	*dst, int	i)
{
	int	save;
	
	if(i < 0)
	{
		*dst = '-';
		return 1 + string_number(dst+1, -i);
	}
	
	if((i/10) > 0)
	{
		save = string_number(dst, i/10);
		dst += save;
	}
	else save = 0;
	
	*dst = '0' + (i%10);
	return 1 + save;
}

int	string_string(char	*dst, char	*src)
{
	strcpy(dst, src);
	return strlen(dst);
}

int	vsprintf(char	*string, char	*format, va_list	args)
{
	char	*start = string;
	
	while(*format)
	{
		if(*format=='%')
		{
			format++;
			switch(*format)
			{
				case	'%':
					*string++ = *format;
					break;
				case	'd':
					string += string_number(string, va_arg(args, int));
					break;
				case	's':
					string += string_string(string, va_arg(args, char*));
					break;
				case	'c':
					*string++ = va_arg(args, int);
					break;
			}
		}
		else *string++ = *format;
		
		format++;
	}
	*string = 0;
	
	return string - start;
}

int	number_string(char	*string, int	*n)
{
	char	*start = string;
	int		sign = 1;
	
	*n = 0;
	while(*string=='-' || *string=='+' || (*string>='0' && *string<='9'))
	{
		if(*string=='-')sign *= -1;
		else if(*string != '+')
		{
			*n *= 10;
			*n += *string - '0';
		}
		string++;
	}
	
	return string - start;
}

int	word_string(char	*string, char	*dst)
{
	char	*start = string;
	
	while(*string>' ')*dst++ = *string++;
	*dst = 0;
	
	return string - start;
}

int	vsscanf(char	*string, char	*format, va_list	args)
{
	int	used;
	
	return vsscanf_with_count(string, &used, format, args);
}

int	vsscanf_with_count(char	*string, int	*used, char	*format, va_list	args)
{
	int	num = 0, temp;
	
	*used = 0;
	
	while(*format && *string)
	{
		if(*format == '%')
		{
			format++;
			if(*format != 'c')
			{
				//skip over any whitespace etc before a parameter
				while(*string && *string<=' ')
				{
					(*used)++;
					string++;
				}
			}
			switch(*format)
			{
				case	'%':
					if(*string++ != *format)return num;
					break;
				case	'd':
					string += temp = number_string(string, va_arg(args, int*));
					(*used) += temp;
					num++;
					break;
				case	's':
					string += temp = word_string(string, va_arg(args, char*));
					(*used) += temp;
					num++;
					break;
				case	'c':
					*(va_arg(args, char*)) = *string++;
					num++;
					(*used)++;
					break;
			}
		}
		else
		{
			if(*format != *string)break;
			string++;
			(*used)++;
		}
		format++;
	}
	
	return num?num:-1;
}

void  __assertion_failed(char const * cnd, char const * file, int line)
{
	printf("ASSERTION FAILED on line %d of file %s: %s\nClick mouse to exit...\n",
				line, file, cnd);
	FlushEvents(everyEvent, 0);
	while(!Button());
	ExitToShell();
}