/*****************************************
 * Steven Stanek
 * September, 01, 2001
 * YZiFormGzip Wrapper (yziformgzwrap.h)
 *
 * NOTES
 * This library's purpose is to provide compression extensions for yziform
 * YZiForm with Compression extensions will only function if this library
 * along with the associated compression libraries is included in the
 * compiled program along with the yziform libraries. It is important to
 * note that yziform will function without this library but will not
 * recognize gzip compressed files.
 *****************************************/

#ifndef yziformgzwrap_h_
#define yziformgzwrap_h_

#define COMP_IMAGE_STR 	"<Begin GZIP Compressed YZiForm Image Size="
#define STEP_SIZE		4096 //In Bytes

#include "yziform.h"
#include <stdio.h>

//YZiForm
yzImage processCompressedString(char *str);
yzImage readCompressedFileImage(FILE *in);

//Compression
void *compressMe(void *data, int length, int *returnlen);
void *decompressMe(void *data, int length, int *returnlen);

//Utility
//Reads file past present position
void *readRestOfFile(FILE *infile, int *returnLen);


#endif